//
//  hash_table_utilities.c
//  
//
//  Created by Ivaylo Dobrikov on 09/07/15.
//
//

#include "hash_table_utilities.h"

struct GraphVertex_hash *vertices_ht = NULL;

void add_vertex_ht(unsigned int atomid, int graphid) {
    struct GraphVertex_hash *vertex_h;
    vertex_h = (struct GraphVertex_hash*)malloc(sizeof(struct GraphVertex_hash));
    vertex_h->atomid = atomid;
    HASH_ADD_INT( vertices_ht, atomid, vertex_h );  /* atomid: name of key field */
    vertex_h->graphid = graphid;
}

// returns vertex graph id
int find_vertex_ht(unsigned int atomid) {
    struct GraphVertex_hash *vertex_h;
    
    HASH_FIND_INT( vertices_ht, &atomid, vertex_h );  /* vertex_h: output pointer */
    return vertex_h ? vertex_h->graphid : -1;
}

void delete_vertex_ht(struct GraphVertex_hash *vertex_h) {
    HASH_DEL( vertices_ht, vertex_h);  /* vertex_h: pointer to delete */
    free(vertex_h);
}

void delete_all_ht() {
    struct GraphVertex_hash *current_vertex, *tmp;
    
    HASH_ITER(hh, vertices_ht, current_vertex, tmp) {
        HASH_DEL(vertices_ht,current_vertex);  /* delete it (users advances to next) */
        free(current_vertex);            /* free it */
    }
}

void print_vertices_ht() {
    struct GraphVertex_hash *vertex_h;
    
    for(vertex_h=vertices_ht; vertex_h != NULL; vertex_h=(struct GraphVertex_hash*)(vertex_h->hh.next)) {
        printf("atomid %d: graphid %d\n", vertex_h->atomid, vertex_h->graphid);
    }
}