#include "ltlc.h"

static int is_safety_property_ref(ltl_formula *f, int signum, int ref) {
  ltl_pform_ref pref;
  pref.ref = ref;
  pref.signum = signum;
  return is_safety_property(f, &pref);
}

static int is_safety_property2(ltl_formula *f, int signum, ltl_pform_ref *ref) {
  ltl_pform_ref pref;
  pref.ref = ref->ref;
  pref.signum = signum ? ref->signum : !ref->signum;
  return is_safety_property(f, &pref);
}

int is_safety_property(ltl_formula *f, ltl_pform_ref *ref) {
  int result,signum;
  if (ref->ref < 0) {
    result = 1;
  } else {
    signum = ref->signum;
    ltl_part_formula *mr = &(f->closure[ref->ref]);
    switch(mr->op) {
    case ltlap:
    case ltltp:
      result = 1; break;
    case ltlnext:
      result = is_safety_property_ref(f,signum,mr->args.case_next); break;
    case ltlnextnot:
      result = is_safety_property_ref(f,!signum,mr->args.case_nextnot); break;
    case ltlyesterday:
      result = is_safety_property_ref(f,signum,mr->args.case_yesterday); break;
    case ltlyesterdaynot:
      result = is_safety_property_ref(f,!signum,mr->args.case_yesterdaynot); break;
    case ltlor:
      result = is_safety_property2(f,signum,&(mr->args.case_or.a))
	&& is_safety_property2(f,signum,&(mr->args.case_or.b));
      break;
    case ltluntil:
      if (ref->signum) {
	result = is_safety_property(f,&(mr->args.case_until.goal)) &&
	  is_safety_property(f,&(mr->args.case_until.inv));
      } else {
	result =  0;
      }
      break;
    case ltlsince:
      result = is_safety_property2(f,signum,&(mr->args.case_since.goal)) &&
	is_safety_property2(f,signum,&(mr->args.case_since.inv));
      break;
    default:
      fprintf(stderr, "unexpected case in is_safety_property\n");
      result = 0; break;
    } 
  }
  return result;
}
