#include <stdlib.h>
#include <stdio.h>
#include <sicstus/sicstus.h>
#include "ltlc.h"

void testnodestore(SP_term_ref list1, SP_term_ref list2) {
  nodestore store;
  SP_term_ref tail1,elem1;
  SP_term_ref tail2,elem2;
  int status;
  ltlnode *node;

  init_nodestore(&store);

  /* new elements */
  tail1 = SP_new_term_ref();
  elem1 = SP_new_term_ref();
  SP_put_term(tail1,list1);

  while (SP_get_list(tail1,elem1,tail1)) {
    status = get_node_by_term(&store, elem1, &node);
    if (!status) {
      printf("error: node should be new!\n");
      exit(1);
    }
  }

  /* old elements */
  tail2 = SP_new_term_ref();
  elem2 = SP_new_term_ref();
  SP_put_term(tail2,list2);

  while (SP_get_list(tail2,elem2,tail2)) {
    status = get_node_by_term(&store, elem2, &node);
    if (status) {
      printf("error: node should be old!\n");
      exit(1);
    }
  }

  delete_nodestore(&store);

  printf("nodestore: test passed.\n");
}
