/*  
    Title: A Profiler for SICStus Prolog
    Author: Philip Höfges
    Heinrich-Heine-University Düsseldorf
    Lehrstuhl für Softwaretechnik und Programmiersprachen
    Prof. Dr. Michael Leuschel, Sebastian Krings
*/
:- module(test2,[test1/2,test2/2,not_profiled_but_including_coro/1,not_profiled_but_including_coro2/1,naming_it/3,condition/2,condition2/3,testing/0,f/0,g/0,my_append/3,my_member/2,gen_list/2]).

:- use_module(profiler).
:- use_module(profiler_te).

:- enable_profiling(cutting/1).

:- block f('-').

test1(X,Y) :-
    profiler:prof_on(test1),
    my_member(X,Y),
    profiler:prof_off(test1).

test2(X,Y) :-
    profiler:prof_on(test2),
    ((Y=[X|_]);(!,Y=[_|T],test2(X,T))),
    profiler:prof_off(test2).

not_profiled_but_including_coro(X) :-
    when(ground(X),(write(X),nl,nl)).

not_profiled_but_including_coro2(X) :-
    when(ground(X),(write(X),nl)).

naming_it(my_member,_,member_cut).
naming_it(my_append,_,append).

condition(A,_) :-
    A = 2.

condition2(A,_,_) :-
    A = [2].

:- coroutines(false).

testing :-
    call(f(1)),
    g,
    gen_list(5,[1,1,1,1,1,2]),
    my_member(2,[1,2,3]),
    my_append([1,2,3],[4,5,6],[1,2,3,4,5,6]).

f(_) :-
    print('Hi, this is f.'),nl.

g :-
    print('Hello, my name is g.'),nl.

my_append([],X,X) :- !.
my_append([H|T],Y,[H|O2]) :-
    my_append(T,Y,O2).

gen_list(0,[2]).
gen_list(Length,O) :-
    Length>0,
    O = [1|T],
    L1 is Length - 1,
    gen_list(L1,T).

my_member(X,[X|_]).
my_member(X,[_|T]) :- !,
    my_member(X,T).