import org.zeromq.ZMQ;

// Compile: javac -cp /path/to/jzmq/src/ StatLeecher.java
// Execute: java -Djava.library.path=/path/to/libjzmq -cp /path/to/jzmq/src/:. StatLeecher


public class StatLeecher {
    public static void main(String[] args) {
        final ZMQ.Context context = ZMQ.context(1);
        final ZMQ.Socket socket = context.socket(ZMQ.SUB);
        socket.subscribe(new byte[0]);
        System.out.println("Connecting to stat socket");
        socket.connect ("tcp://localhost:5010");
        
        boolean stop = false;
        while (!stop) {
            final byte[] reply = socket.recv(0);
            final String msg = new String(reply);
            System.out.println(msg);
            
            if (msg.equals("TERM")) {
                    stop = true;
            }
        }
        socket.close();
        context.term();
    }
}
