#include "../include/zmq.h"
#include "../include/czmq.h"

#include "CuTest.h"
#include "../master/mctrl.h"

extern zctx_t *ctx;
static void *tmp_socket;

extern int port;

static void init(void) {
    init_send_ctrl(ctx, port-7);
    tmp_socket = zsocket_new(ctx, ZMQ_SUB);
    char *filter = "";
    zmq_setsockopt (tmp_socket, ZMQ_SUBSCRIBE, filter, strlen (filter));
    zsocket_connect (tmp_socket, "tcp://localhost:%d", port);
    sleep(1);
    port++;
}

static void teardown(void) {
    teardown_send_ctrl(ctx);
    zsocket_destroy(ctx, tmp_socket);
}

void Test_send_ctrl(CuTest *cu) {
    init();

    send_term();
    int rc = zsocket_poll(tmp_socket, 5000);
    CuAssertTrue(cu, rc);
    char *str = zstr_recv(tmp_socket);
    CuAssertStrEquals(cu, "TERM", str);
    free(str);

    teardown();
}
