#!/bin/bash
# can be used like this: git bisect run ./gitperfcheck.sh FILE ARGS
# usually it is better to make a copy of this file which is not versioned inside git
#PROBCOMMAND=probcli
PROBCOMMAND='sicstus -l /Users/leuschel/git_root/prob_prolog/src/prob_cli.pl --goal go_cli,halt. -a'
# this is the limit in s: something slower or equal to this will be reported as bad
LIMIT=12
# probsli requires about 11 seconds to start
FILE=""
OPTIONS="-version $*"

# Making probcli; only necessary if we use probcli for PROBCOMMAND
# some revisions cannot be built !
#echo "Making probcli"
#make prob || exit 125

echo "Git Performance Regression Test"
START_TIME=$SECONDS
echo " --> Running $PROBCOMMAND $FILE $OPTIONS"
$PROBCOMMAND $FILE $OPTIONS
ELAPSED_TIME=$(($SECONDS - $START_TIME))
echo " --> Elapsed time = $ELAPSED_TIME seconds"
# git rev-parse HEAD
#git show | cat
git show --pretty=format:"Commit: %H%n   Msg: %s %n  Date: %cd" | cat


# check if we are fast enough:
if [ $ELAPSED_TIME \< $LIMIT ]
then
  echo " --> Good"
  exit 0
else
  echo " --> Bad"
  exit 2
fi
# exit 2 signals bad to git, 0 signals good to git