% (c) 2009-2015 Lehrstuhl fuer Softwaretechnik und Programmiersprachen, 
% Heinrich Heine Universitaet Duesseldorf
% This software is licenced under EPL 1.0 (http://www.eclipse.org/org/documents/epl-v10.html) 


:- module(tools_lists,
                 [count_occurences/2
                  ]).

:- use_module(module_information).

:- module_info(group,infrastructure).
:- module_info(description,'A few utilities on lists seperated out from tools.pl to avoid cyclic module dependencies.').


% self-check in tools to avoid dependency on self_check module
%:- assert_must_succeed((tools:count_occurences([a,b,a,a,b],R),R == [a-3,b-2])).
:- use_module(library(avl), [avl_fetch/3, avl_to_list/2, avl_store/4,empty_avl/1]).

% count number of occurences inside a list
count_occurences(L,R) :- empty_avl(E), count_occ_aux(L,E,R).
count_occ_aux([Term|T],A,Res) :- (avl_fetch(Term,A,Count) -> C is Count+1 ; C = 1),
   avl_store(Term,A,C,A2),
   count_occ_aux(T,A2,Res).
count_occ_aux([],A,L) :- avl_to_list(A,L).